function samples = remove_boundary_samples(M, samples, max_radius)

if max_radius==0
    return
end

% remove samples close to scene boundary

bd_e = get_boundary_edges(M.TRIV);
bd_v = unique(bd_e);

to_remove = false(length(samples),1);

for i=1:length(samples)
    
    if any(samples(i) == bd_v) % it is a boundary vertex itself
        to_remove(i) = true;
        continue;
    end
    
    idx = ( max_radius >= sqrt(sum((repmat(M.VERT(samples(i),:), length(bd_v), 1) - M.VERT(bd_v,:)).^2, 2)) );
    
%     figure,plot_mesh(S),shading interp,hold on, plot_cloud(S, samples(i), 'ro')
%     plot_cloud(S, bd_v(idx), 'b.')

    if any(idx)
        to_remove(i) = true;
    end
    
end

samples(to_remove) = [];

end
